#include "GVN.h"
#include "SimplifyInstructions.h"


vector<GetElementPtrInstruction*> geps;



void GVN(BlockPtr block)
{
    geps.clear();
    cout << "Enter GVN" << endl;
    // for(auto bb: block->basicBlocks)
    // {
    //     for(auto instr:bb->instructions)
    //     {
    //         if(instr->type == GEP)
    //         {
    //             auto gepins = dynamic_cast<GetElementPtrInstruction*>(instr.get());
    //             geps.push_back(gepins);
    //         }
                
    //     }
    // }

    for(auto bb: block->basicBlocks)
    {
        bool modified = false;
        unordered_set<InstructionPtr> toDelete;
        toDelete.clear();
        for(auto instr: bb->instructions)
        {
            // cout << "Here!!!" << endl;
            if(instr->type == GEP)
            {
                // auto bi = dynamic_cast<BinaryInstruction*>(instr.get());
                // cout << "Here!!!" << endl;
                auto target = dynamic_cast<GetElementPtrInstruction*> (instr.get());
                bool flag = false;
                for (auto pre : geps)
                {
                    if (pre->from == target->from && pre->index.size() == target->index.size())
                    {
                        bool flag2 = false;
                        
                        for (int i = 0; i < pre->index.size(); i++)
                        {
                            if(pre->index[i] != target->index[i] || !pre->index[i]->isConst)
                            {
                                flag2 = true;
                                break;
                            }
                        }

                        if(!flag2)
                        {
                            auto prebb = pre->basicblock;
                            auto curbb = target->basicblock;

                            if(curbb->allDoms.count(prebb))
                            {
                                flag = true;
                                toDelete.insert(instr);
                                replaceVarByVar(target->reg, pre->reg);
                                deleteUser(target->reg);
                                modified = true;
                                break;
                            }
                        }
                    }
                }
                if(!flag)
                    geps.push_back(target);
            }
        }

        if(modified)
        {
            // cout<< "Modified!!!" <<endl;
            // for(auto myins: toDelete)
            // {
            //     myins->print();
            // }
            vector<InstructionPtr> newIns;
            for(auto instr: bb->instructions)
            {
                if(!toDelete.count(instr))
                    newIns.push_back(instr);
            }
            bb -> instructions = newIns;
        }
        toDelete.clear();
    }
}
