#pragma once

#include <unordered_map>
#include <numeric>
#include <queue>
#include "Module.h"
#include "Loop.h"

bool isCallIdempotent(CallInstruction *ins);
void runForLoop(BlockPtr block, LoopPtr loop, int& moveCount);
void LICM(BlockPtr block, bool hasMod=false);
bool isLoopInvariant(InstructionPtr instr, LoopPtr curLoop, BlockPtr block, set<Instruction *>& toDelete);