#include <iostream>
#include <vector>
#include <unordered_map>
#include <queue>
#include <stack>
#include <sstream>

#include "Module.h"
#include "Loop.h"
#include "SCEV.h"


void discoverAndMapSubloop(LoopPtr loop, BlockPtr func, stack<BasicBlockPtr>& BackedgeTo);
void computeExitingBlocks(BlockPtr block);
void computeExitBlocks(BlockPtr block);
void computePreHeader(BlockPtr block);
void computeLatch(BlockPtr block);
void computeLoopIndVar(BlockPtr block);
void computeLoopBB(BlockPtr block);
void getLoopDepth(BlockPtr block);
void loopAnalysis(BlockPtr block);
